package filter
{
	import flash.display.BitmapData;
	import flash.display.Shader;
	
	/**	See superclass DisksFilter for further information */
	public class DiskTransitionFilter extends DisksFilter
	{
		
		/**	embedded .pbj files	*/
		[Embed(source='shaders/DisksTransition.pbj', mimeType = 'application/octet-stream')]
		protected var DisksTransitionShader:Class;
		
		
		public function DiskTransitionFilter(_input:BitmapData, _output:BitmapData)
		{
			super(_input, _output);
			this.shader= new Shader(new DisksTransitionShader());
		}
		
		
		/**	set radius2 */
		public function set radius2(value:Number):void {
			shader.data.radius2.value= [value];
			update();
		}
		
		[Bindable]
		public function get radius2():Number { 
			return shader.data.radius2.value[0];
		}
		
		
		/**	Set the destination bitmapdata */
		public override function set output(value:BitmapData):void {
			this._output = value;
			if (value!=null) shader.data.imageWidth.value= [value.width];
			update();
		}
		public override function get output():BitmapData {
			return this._output;
		}
	}
}