package net
{
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.net.FileReference;
	
	import mx.controls.Alert;
	import mx.graphics.codec.PNGEncoder;
	
	/** 
	 * Class for saving a bitmapData from flash player to png-file on local computer.
	 * 
	 * Usage: 
	 * new PngFormatExporter(bitmapData, "defaultFileName.png");
	 * 
	 */ 
	public class PngFormatExporter extends FileReference
	{
		
		protected var 
			completedFunction:Function,
			canceledFunction:Function;
	
		public function PngFormatExporter(bmd:BitmapData, 
										  defaultFileName:String=null, 
										  completed:Function=null, 
										  canceled:Function=null)
		{
			super();
			this.completedFunction = completed;
			this.canceledFunction = canceled;
			
			this.addEventListener(Event.COMPLETE, fileSaveComplete);
			this.addEventListener(Event.CANCEL, fileSaveCanceled);
			
			if (bmd!=null) this.save(encoder.encode(bmd), defaultFileName);
			
		}
		
		protected function get encoder():* {
			return new PNGEncoder();
		}
		
		protected function fileSaveComplete(e:Event):void {
			Alert.show('Image File Exported!', 'Tiling', mx.controls.Alert.OK);
			if (this.completedFunction!=null) this.completedFunction(e);
		}
		
		protected function fileSaveCanceled(e:Event):void {
			Alert.show('Export Canceled.', 'Tiling', mx.controls.Alert.OK);
			if (this.canceledFunction!=null) this.canceledFunction(e);
		}

		
		
		
		
	}
}